unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation


uses
  {A LIRE}
  // La clause Uses permet d'tablir le lien des units Unit2 et Unit3 vers Unit1
  // et d'utiliser les objets qui y sont dfinis (variables, types...)
  // TForm2, Form2  et TForm3 deviennent ainsi utilisables dans Unit1
  Unit2,
  Unit3;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
{A LIRE}
  // L'utilisation de Form2 est licite car la fiche est auto-cre dans le
  // source du projet
  Form2.ShowModal;
End;

procedure TForm1.Button2Click(Sender: TObject);
var
  Form2_2: TForm2;
begin
{A LIRE}
// ici, on veut afficher une autre fiche TForm2 sans utiliser la variable Form2
// dclare par Delphi
  Form2_2 := TForm2.Create(Application);
  try
    Form2_2.ShowModal;
  finally
    Form2_2.Release;
    // comme la variable Fomr2_2 est locale, elle est perdue aprs l'excution
    // de Button2Click() et ne ncessite pas de traitement particulier.
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
{A LIRE}
//  Form3 est globale (dclare en interface de Unit3), mais non initialise par
// l'auto-cration dans le source du projet donc nous allons la crer :
  Form3 := TForm3.Create(Application);
  try
     Form3.ShowModal;
  finally
    Form3.Release;
    Form3 := Nil; // prfrable car Form3 est globable, aprs le release,
    // l'objet TForm3 est dtruit et la rfrence Form3 devient invalide.
  end;
End;

end.
